triggerProcessEventResult = {
    actionToTrigger = nil,
    actionArguments = nil,
}

local Type__updateContext = {
    playerInfo = {
        playerEntity = nil
    },
    scoreManager = nil,
    triggerState = nil,
}

Trigger = {}

function Trigger:new(type)
    
    local this = {
        type = type,
        eventsToListen = {},
        shouldCheckEveryFrame = false,
    }

    function this:createBaseState(config)
        return {
            config = config,
            description = {
                intent = "intent not set for Base Trigger",
                oneLinerWithState = "oneLinerWithState not set for Base Trigger",
                detail = "Header not set for Base Trigger",
            },
            state = {
                testy = "ASDF"
            },
        }
    end

    function this:triggerProcessEventResult()
        return {
            actionToTrigger = nil,
            actionArguments = nil,
        }
    end

    function this:processEvent(event, state)
        print("----------------- BASIC")
    end

    function this:hasTag(tagName)
        return string.find(self.config.tags, tagName)
    end

    function this:init() 
    end

    function this:updateStateDescription(updateContext)
        --self.config.description.header = "Update"
    end

    setmetatable(this,self)
    self.__index = self
    return this
end